/*
 * tft_init.c
 *
 *  Created on: 20231214
 *      Author: lceda
 */
#include "tft_init.h"


//#define TFT_SCL PB13
//#define TFT_SDA PB15
//#define TFT_DC  PC6
//#define TFT_CS  PB12
//#define TFT_BLK PA8

static void Init_SPI_GPIO(void)
{
    GPIO_InitTypeDef GPIO_InitStructure = {0};              //ʼGPIOṹ
    SPI_InitTypeDef  SPI_InitStructure  = {0};              //ʼSPIṹ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);   //ʹGPIOB ʱ
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2, ENABLE);    //ʹSPI2  ʱ

    GPIO_InitStructure.GPIO_Pin   = GPIO_Pin_13|GPIO_Pin_15;//SPI-SCK||SPI_MOSI
    GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_AF_PP;        //
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);


    SPI_InitStructure.SPI_Direction         = SPI_Direction_1Line_Tx;   //SPI߷ģʽ
    SPI_InitStructure.SPI_Mode              = SPI_Mode_Master;          //SPIģʽ
    SPI_InitStructure.SPI_DataSize          = SPI_DataSize_8b;          //λ8λ
    SPI_InitStructure.SPI_CPOL              = SPI_CPOL_Low;             //мΪ
    SPI_InitStructure.SPI_CPHA              = SPI_CPHA_1Edge;           //һز
    SPI_InitStructure.SPI_NSS               = SPI_NSS_Soft;             //Ƭѡźı
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_2;  //SPIʱ2Ƶ
    SPI_InitStructure.SPI_FirstBit          = SPI_FirstBit_MSB;         //λǰ
    SPI_InitStructure.SPI_CRCPolynomial     = 7;                        //7λCRCУ
    SPI_Init(SPI2, &SPI_InitStructure);                                 //ʼSPI2

    SPI_Cmd(SPI2, ENABLE);                                              //ʹSPI2
}

/*
 * ݣSPI2 
 * data ֽڴ
 * ֵ     
 */
static void SPI2_Write(uint8_t data)
{
    while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_TXE) == RESET)  //ⷢ״̬
        ;
    SPI_I2S_SendData(SPI2, data);   //͵ֽ

    while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_BSY) == SET)    //ȴ
        ;
}
/*
 * ݣʼ2.0TFT
 * 
 * ֵ    
 */
static void TFT_GPIO_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStructure = {0};
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    GPIO_SetBits(GPIOB,GPIO_Pin_13|GPIO_Pin_15|GPIO_Pin_12);
    GPIO_SetBits(GPIOC,GPIO_Pin_6);
    GPIO_SetBits(GPIOA,GPIO_Pin_8);
}

/*
 * ݣTFTд
 * data Ҫд
 * ֵ
 */
static void TFT_Writ_Bus(uint8_t data)
{
    uint8_t i=0;
    GPIO_ResetBits(GPIOB,GPIO_Pin_12);  //Ƭѡź
    for(i=0;i<8;i++)
    {
        GPIO_ResetBits(GPIOB,GPIO_Pin_13);  //ʱź
        if((data&0x80)==0x80)
        {
            GPIO_SetBits(GPIOB,GPIO_Pin_15);    //ź
        }
        else {
            GPIO_ResetBits(GPIOB,GPIO_Pin_15);  //ź
        }
        GPIO_SetBits(GPIOB,GPIO_Pin_13);    //ʱź
        data=data<<1;
    }
    GPIO_SetBits(GPIOB,GPIO_Pin_12);        //Ƭѡź
}

/*
 * ݣTFTд
 * data д
 * ֵ     
 */
void TFT_WR_DATA8(uint8_t data)
{
    //TFT_Writ_Bus(data);
    GPIO_ResetBits(GPIOB,GPIO_Pin_12);  //Ƭѡź
    SPI2_Write(data);
    GPIO_SetBits(GPIOB,GPIO_Pin_12);    //Ƭѡź
}

/*
 * ݣTFTд2ֽ
 * data д
 * ֵ     
 */
void TFT_WR_DATA(uint16_t data)
{
    //TFT_Writ_Bus(data>>8);
    //TFT_Writ_Bus(data);
    GPIO_ResetBits(GPIOB,GPIO_Pin_12);  //Ƭѡź
    SPI2_Write(data>>8);
    SPI2_Write(data);
    GPIO_SetBits(GPIOB,GPIO_Pin_12);    //Ƭѡź
}

/*
 * ݣTFTд
 * data д
 * ֵ     
 */
void TFT_WR_REG(uint8_t data)
{
    //GPIO_ResetBits(GPIOC,GPIO_Pin_6);
    //TFT_Writ_Bus(data);
    //GPIO_SetBits(GPIOC,GPIO_Pin_6);
    GPIO_ResetBits(GPIOC,GPIO_Pin_6);   //źţʱǷ
    GPIO_ResetBits(GPIOB,GPIO_Pin_12);  //Ƭѡź
    SPI2_Write(data);
    GPIO_SetBits(GPIOB,GPIO_Pin_12);    //Ƭѡź
    GPIO_SetBits(GPIOC,GPIO_Pin_6);     //źţ
}

/*
 * ݣʼͽַ
 * x1,x2 еʼַ
 *        y1y2 еʼַ
 * ֵ     
 */
void TFT_Address_Set(uint16_t x1,uint16_t y1,uint16_t x2,uint16_t y2)
{
    if(USE_HORIZONTAL==0)
    {
        TFT_WR_REG(0x2a);//еַ
        TFT_WR_DATA(x1);
        TFT_WR_DATA(x2);
        TFT_WR_REG(0x2b);//еַ
        TFT_WR_DATA(y1);
        TFT_WR_DATA(y2);
        TFT_WR_REG(0x2c);//д
    }
    else if(USE_HORIZONTAL==1)
    {
        TFT_WR_REG(0x2a);//еַ
        TFT_WR_DATA(x1);
        TFT_WR_DATA(x2);
        TFT_WR_REG(0x2b);//еַ
        TFT_WR_DATA(y1);
        TFT_WR_DATA(y2);
        TFT_WR_REG(0x2c);//д
    }
    else if(USE_HORIZONTAL==2)
    {
        TFT_WR_REG(0x2a);//еַ
        TFT_WR_DATA(x1);
        TFT_WR_DATA(x2);
        TFT_WR_REG(0x2b);//еַ
        TFT_WR_DATA(y1);
        TFT_WR_DATA(y2);
        TFT_WR_REG(0x2c);//д
    }
    else
    {
        TFT_WR_REG(0x2a);//еַ
        TFT_WR_DATA(x1);
        TFT_WR_DATA(x2);
        TFT_WR_REG(0x2b);//еַ
        TFT_WR_DATA(y1);
        TFT_WR_DATA(y2);
        TFT_WR_REG(0x2c);//д
    }
}

/*
 * ݣʼTFTĻ
 * 
 * ֵ    
 */
void TFT_Init(void)
{
    Init_SPI_GPIO();//ʼSPI
    TFT_GPIO_Init();//ʼGPIO

    GPIO_SetBits(GPIOA,GPIO_Pin_8);//򿪱
    Delay_Ms(100);


    TFT_WR_REG(0x11);
    Delay_Ms(120);

    TFT_WR_REG(0x36);
    if(USE_HORIZONTAL==0)TFT_WR_DATA8(0x00);
    else if(USE_HORIZONTAL==1)TFT_WR_DATA8(0xC0);
    else if(USE_HORIZONTAL==2)TFT_WR_DATA8(0x70);
    else TFT_WR_DATA8(0xA0);

    TFT_WR_REG(0x3A);
    TFT_WR_DATA8(0x05);

    TFT_WR_REG(0xB2);
    TFT_WR_DATA8(0x0C);
    TFT_WR_DATA8(0x0C);
    TFT_WR_DATA8(0x00);
    TFT_WR_DATA8(0x33);
    TFT_WR_DATA8(0x33);

    TFT_WR_REG(0xB7);
    TFT_WR_DATA8(0x35);

    TFT_WR_REG(0xBB);
    TFT_WR_DATA8(0x32); //Vcom=1.35V

    TFT_WR_REG(0xC2);
    TFT_WR_DATA8(0x01);

    TFT_WR_REG(0xC3);
    TFT_WR_DATA8(0x15); //GVDD=4.8V  ɫ

    TFT_WR_REG(0xC4);
    TFT_WR_DATA8(0x20); //VDV, 0x20:0v

    TFT_WR_REG(0xC6);
    TFT_WR_DATA8(0x0F); //0x0F:60Hz

    TFT_WR_REG(0xD0);
    TFT_WR_DATA8(0xA4);
    TFT_WR_DATA8(0xA1);

    TFT_WR_REG(0xE0);
    TFT_WR_DATA8(0xD0);
    TFT_WR_DATA8(0x08);
    TFT_WR_DATA8(0x0E);
    TFT_WR_DATA8(0x09);
    TFT_WR_DATA8(0x09);
    TFT_WR_DATA8(0x05);
    TFT_WR_DATA8(0x31);
    TFT_WR_DATA8(0x33);
    TFT_WR_DATA8(0x48);
    TFT_WR_DATA8(0x17);
    TFT_WR_DATA8(0x14);
    TFT_WR_DATA8(0x15);
    TFT_WR_DATA8(0x31);
    TFT_WR_DATA8(0x34);

    TFT_WR_REG(0xE1);
    TFT_WR_DATA8(0xD0);
    TFT_WR_DATA8(0x08);
    TFT_WR_DATA8(0x0E);
    TFT_WR_DATA8(0x09);
    TFT_WR_DATA8(0x09);
    TFT_WR_DATA8(0x15);
    TFT_WR_DATA8(0x31);
    TFT_WR_DATA8(0x33);
    TFT_WR_DATA8(0x48);
    TFT_WR_DATA8(0x17);
    TFT_WR_DATA8(0x14);
    TFT_WR_DATA8(0x15);
    TFT_WR_DATA8(0x31);
    TFT_WR_DATA8(0x34);
    TFT_WR_REG(0x21);

    TFT_WR_REG(0x29);
}
